<template>
  <div v-if="hasPermission">
    <h2>My Song Lists</h2>
    <ul class="list-unstyled">
      <li v-for="list in lists" v-bind:key="list.id">
        <el-link @click="showListSongs(list.id)" :underline="false">{{ list.name }}</el-link>
      </li>
    </ul>
    <el-button v-if="!addNewList" type="success" plain @click="addNewList = true">Add new list</el-button>
    <div v-if="addNewList">
      <el-form :model="newList" ref="newList">
        <el-input v-model="newList.name"></el-input>
        <el-button @click="addList(newList)">Add</el-button>
      </el-form>
    </div>
  </div>
</template>

<script>
    import Requester from "@/controllers/requests/list.js";
    import auth from "@/controllers/requests/auth.js";
    import userRole from "@/controllers/enums.js";

    const requester = new Requester();
    export default {
        name: "ListList",
        data() {
            return {
                lists: {},
                hasPermission: false,
                addNewList: false,
                newList: {
                    name: ""
                }
            }
        },

        created() {
            auth.hasPermission(userRole.writer).then(() => {
                this.hasPermission = true;
                this.getLists();
            }).catch(() => {
                this.hasPermission = false;
            });
        },

        mounted() {
            this.$root.$on("changedUserLogState", () => {
                auth.hasPermission(2).then(() => {
                    this.hasPermission = true;
                }).catch(() => {
                    this.hasPermission = false;
                });
            });

        },
        methods: {
            getLists() {
                requester.getAllLists().then(res => {
                    this.lists = res;
                })
            },
            showListSongs(listID) {
                this.$root.$emit("sortByList", listID);
                if (this.$router.currentRoute.path !== "/songs" || this.$router.currentRoute.path !== "/") {
                    this.$router.push({name: 'home'})
                }
            },
            addList(data) {
                requester.postNewList(data).then(() => {
                    this.$notify.success({
                        title: 'Success',
                        message: 'Song was successfully updated.'
                    });
                    return true;
                }).catch(err => {
                    this.$notify.error({
                        title: 'Error',
                        message: err
                    });
                })
            }
        }
    }
</script>

<style scoped>

</style>
